﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region
#Extends: com.tillekesoft.accessibilityservices.AccessibilityEventsListenerWrapper 


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public acs As AccessibilityEventsListener
	Private AccServConstants As AccessibilityConstants
	Private ShallWeSendWhatsApp As Boolean
	Private success As Boolean = False
	Private lastbackout As Boolean = False
End Sub

Sub Service_Create
	Log("service was created")
	acs.initialize("acs")
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	Log("service was started")
	
	'Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

Sub Service_Destroy

End Sub


Sub CheckIfServiceIsEnabled
	If acs.IsAccessibilityServiceEnabled("com.mytest/.accservice")  = False Then 'insert package-name and name of your service
		CallSub2(Main,"IsTheAccessibilityServiceEnabled", False)
		CallSub2(Main,"SetCheckbox", False)
	Else
		CallSub2(Main,"IsTheAccessibilityServiceEnabled", True)
		CallSub2(Main,"SetCheckbox", True)
	End If
End Sub

Sub acs_OnAccessibilityEvent (Event As Object, node As Object) 'ignore
	'just some logging.....
	Log("my event: " & Event)
	Log("my node: " & node)
	Dim mylist As List
	mylist.Initialize2(node)
	Log(mylist.Size)
									
	If ShallWeSendWhatsApp = True Then
		For Each item As String In mylist
			If success = False Then
				'#######
				'Pienso que la siguiente linea (sucess = ) es la que se debe 
				'de modificar para elegir un contacto (mi contacto seguro),
				'despues poner un delay y lanzar ahora si la siguiente
				'linea para que consuma el evento de enviar.
				'Algo asi sieto que seria lo corecto:
				
				'Action: Click
				'UI Element Class: android.widget.TextView
				'Ui Element Text: John Doe
				'UI Element ID: com.whatsapp:id/conversations_row_contact_name
				
				'A lo que interpreto, es que con accesibilidad toma control del
				'EditText y pone el nombre y de alli lanza el action (o enter) como
				'en la linea de abajo que lanza un Action_Click
				
				'Como comente, creo que seria algo asi:
				'
				
				'Se abre el buscador de contactos (Funciona esto para abrir el edit)
				success = acs.PerformNodeActionOnViewWithArgs(True,"com.whatsapp:id/menuitem_search",AccServConstants.ACTION_CLICK, Null)
				Log("Buscar")
				acs.delay(500)
								
				'Ingresa contacto desde portapapeles
				Dim cl As BClipboard
				cl.setText("Lya") 'o numero tambien se puede buscar				
				success = acs.PerformNodeActionOnViewWithArgs(True,"com.whatsapp:id/search_src_text",AccServConstants.ACTION_PASTE, Null)
				Log("Dos")
				
				acs.delay(1500)
				
				'Oprime tecla backspace y oculta teclado
				acs.PerformGlobalAction(AccServConstants.GLOBAL_ACTION_BACK)
				Log("tres")
				
				acs.delay(1500)
				
				'########
				'No logro seleccionar el contacto, llego hasta la parte de buscarlo
				'pero ya logro seleccionar la burbuja que lo contiene
				'Las acciones anteriores las saque de los eventos dados del log
				'pero no encuentro el que dispara la seleccion del contacto
				'#######
				
				'Selecciona contacto elegido
				'actionaction_accesi_focus  	'selection_check
								
				success = acs.PerformNodeActionOnViewWithArgs(True,"com.whatsapp:id/contactpicker",AccServConstants.ACTION_SELECT, Null)
				Log("cuatro")
				
				acs.delay(1500)
				
				'
				success = acs.PerformNodeActionOnViewWithArgs(True,"com.whatsapp:id/selection_check",AccServConstants.ACTION_SELECT, Null)
				Log("cinco")
				
				'Return
				
				acs.delay(1500)
				
				
				success = acs.PerformNodeActionOnViewWithArgs(True, "com.whatsapp:id/send",AccServConstants.ACTION_CLICK, Null)
				acs.delay(500)
				'######
				
				'success = acs.PerformNodeActionOnViewWithArgs(True, "com.whatsapp:id/send",AccServConstants.ACTION_CLICK, Null)
				
			Else if success = True And lastbackout = False Then
				acs.delay(500)
				acs.PerformGlobalAction(AccServConstants.GLOBAL_ACTION_BACK)
				acs.delay(500)
				lastbackout = True
			else if success = True And lastbackout = True Then
				acs.PerformGlobalAction(AccServConstants.GLOBAL_ACTION_BACK)
				ShallWeSendWhatsApp = False
				success = False
				lastbackout = False
			End If
		Next
	End If
End Sub

Sub SendWhatsAppMsg
	ShallWeSendWhatsApp = True
End Sub
